move config directory to ~/.monkeysphere
[monkeysphere.git] / src / monkeysphere
index aaeda117a0efd54d6a8ae7dcf4089fa7fe37fed8..59cb3d6ac45764e255fa1135f2eecdee24ca5541 100755 (executable)
@@ -1,9 +1,11 @@
-#!/bin/sh
+#!/bin/bash
 
 # monkeysphere: MonkeySphere client tool
 #
 # The monkeysphere scripts are written by:
 # Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 #
 # They are Copyright 2008, and are all released under the GPL, version 3
 # or later.
 ########################################################################
 PGRM=$(basename $0)
 
-SHAREDIR=${SHAREDIR:-"/usr/share/monkeysphere"}
-export SHAREDIR
-. "${SHAREDIR}/common"
-
-GLOBAL_CONFIG=${GLOBAL_CONFIG:-"${ETC}"/monkeysphere.conf}
-[ -r "$GLOBAL_CONFIG" ] && . "$GLOBAL_CONFIG"
+SHARE=${MONKEYSPHERE_SHARE:-"/usr/share/monkeysphere"}
+export SHARE
+. "${SHARE}/common" || exit 1
 
 # date in UTF format if needed
 DATE=$(date -u '+%FT%T')
 
 # unset some environment variables that could screw things up
-GREP_OPTIONS=
+unset GREP_OPTIONS
+
+# default return code
+RETURN=0
+
+# set the file creation mask to be only owner rw
+umask 077
 
 ########################################################################
 # FUNCTIONS
 ########################################################################
 
 usage() {
-cat <<EOF
-usage: $PGRM <subcommand> [args]
-Monkeysphere client tool.
+    cat <<EOF >&2
+usage: $PGRM <subcommand> [options] [args]
+MonkeySphere client tool.
 
 subcommands:
-  update-known_hosts (k) [HOST]...  update known_hosts file
-  update-authorized_keys (a)        update authorized_keys file
-  update-userids (u) [USERID]...    add/update userid
-  gen-ae-subkey (g) KEYID           generate an 'ae' capable subkey
-  help (h,?)                        this help
+ update-known_hosts (k) [HOST]...    update known_hosts file
+ update-authorized_keys (a)          update authorized_keys file
+ gen-subkey (g) [KEYID]              generate an authentication subkey
+   --length (-l) BITS                  key length in bits (2048)
+   --expire (-e) EXPIRE                date to expire
+ subkey-to-ssh-agent (s)             store authentication subkey in ssh-agent
+ help (h,?)                          this help
 
 EOF
 }
 
-# generate a subkey with the 'a' and 'e' usage flags set
-gen_ae_subkey(){
+# generate a subkey with the 'a' usage flags set
+gen_subkey(){
+    local keyLength
+    local keyExpire
     local keyID
     local gpgOut
     local userID
 
-    log "warning: this function is still not working."
+    # set default key parameter values
+    keyLength=
+    keyExpire=
 
-    keyID="$1"
+    # get options
+    TEMP=$(getopt -o l:e: -l length:,expire: -n "$PGRM" -- "$@")
 
-    # set subkey defaults
-    SUBKEY_TYPE=${KEY_TYPE:-"RSA"}
-    SUBKEY_LENGTH=${KEY_LENGTH:-"1024"}
-    SUBKEY_USAGE=${KEY_USAGE:-"encrypt,auth"}
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
 
-    gpgOut=$(gpg --fixed-list-mode --list-keys --with-colons \
-       "$keyID" 2> /dev/null)
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -l|--length)
+               keyLength="$2"
+               shift 2
+               ;;
+           -e|--expire)
+               keyExpire="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
+
+    if [ -z "$1" ] ; then
+       # find all secret keys
+       keyID=$(gpg --with-colons --list-secret-keys | grep ^sec | cut -f5 -d: | sort -u)
+       # if multiple sec keys exist, fail
+       if (( $(echo "$keyID" | wc -l) > 1 )) ; then
+           echo "Multiple secret keys found:"
+           echo "$keyID"
+           failure "Please specify which primary key to use."
+       fi
+    else
+       keyID="$1"
+    fi
+    if [ -z "$keyID" ] ; then
+       failure "You have no secret key available.  You should create an OpenPGP
+key before joining the monkeysphere. You can do this with:
+   gpg --gen-key"
+    fi
+
+    # get key output, and fail if not found
+    gpgOut=$(gpg --quiet --fixed-list-mode --list-secret-keys --with-colons \
+       "$keyID") || failure
 
-    # return 1 if there only "tru" lines are output from gpg
-    if [ -z "$(echo "$gpgOut" | grep -v '^tru:')" ] ; then
-       loge "  key not found."
-       return 1
+    # fail if multiple sec lines are returned, which means the id
+    # given is not unique
+    if [ $(echo "$gpgOut" | grep -c '^sec:') -gt '1' ] ; then
+       failure "Key ID '$keyID' is not unique."
     fi
 
-    userID=$(echo "$gpgOut" | grep "^uid:" | cut -d: -f10)
+    # prompt if an authentication subkey already exists
+    if echo "$gpgOut" | egrep "^(sec|ssb):" | cut -d: -f 12 | grep -q a ; then
+       echo "An authentication subkey already exists for key '$keyID'."
+       read -p "Are you sure you would like to generate another one? (y/N) " OK; OK=${OK:N}
+       if [ "${OK/y/Y}" != 'Y' ] ; then
+           failure "aborting."
+       fi
+    fi
 
-    # set key parameters
-    keyParameters=$(cat <<EOF
-Subkey-Type: $SUBKEY_TYPE
-Subkey-Length: $SUBKEY_LENGTH
-Subkey-Usage: $SUBKEY_USAGE
-Name-Real: $userID
+    # set subkey defaults
+    # prompt about key expiration if not specified
+    keyExpire=$(get_gpg_expiration "$keyExpire")
+
+    # generate the list of commands that will be passed to edit-key
+    editCommands=$(cat <<EOF
+addkey
+7
+S
+E
+A
+Q
+$keyLength
+$keyExpire
+save
 EOF
 )
 
-    log "The following key parameters will be used:"
-    echo "$keyParameters"
+    log verbose "generating subkey..."
+    fifoDir=$(mktemp -d)
+    (umask 077 && mkfifo "$fifoDir/pass")
+    echo "$editCommands" | gpg --passphrase-fd 3 3< "$fifoDir/pass" --expert --command-fd 0 --edit-key "$keyID" &
+
+    passphrase_prompt  "Please enter your passphrase for $keyID: " "$fifoDir/pass"
 
-    read -p "generate key? [Y|n]: " OK; OK=${OK:=Y}
-    if [ ${OK/y/Y} != 'Y' ] ; then
-       failure "aborting."
+    rm -rf "$fifoDir"
+    wait
+    log verbose "done."
+}
+
+function subkey_to_ssh_agent() {
+    # try to add all authentication subkeys to the agent:
+
+    local sshaddresponse
+    local secretkeys
+    local authsubkeys
+    local workingdir
+    local keysuccess
+    local subkey
+    local publine
+    local kname
+
+    if ! test_gnu_dummy_s2k_extension ; then
+       failure "Your version of GnuTLS does not seem capable of using with gpg's exported subkeys.
+You may want to consider patching or upgrading.
+
+For more details, see:
+ http://lists.gnu.org/archive/html/gnutls-devel/2008-08/msg00005.html"
     fi
 
-    # add commit command
-    keyParameters="${keyParameters}"$(cat <<EOF
+    # if there's no agent running, don't bother:
+    if [ -z "$SSH_AUTH_SOCK" ] || ! which ssh-add >/dev/null ; then
+       failure "No ssh-agent available."
+    fi
 
-%commit
-%echo done
-EOF
-)
+    # and if it looks like it's running, but we can't actually talk to
+    # it, bail out:
+    ssh-add -l >/dev/null
+    sshaddresponse="$?"
+    if [ "$sshaddresponse" = "2" ]; then
+       failure "Could not connect to ssh-agent"
+    fi
+    
+    # get list of secret keys (to work around https://bugs.g10code.com/gnupg/issue945):
+    secretkeys=$(gpg --list-secret-keys --with-colons --fixed-list-mode --fingerprint | \
+       grep '^fpr:' | cut -f10 -d: | awk '{ print "0x" $1 "!" }')
+
+    if [ -z "$secretkeys" ]; then
+       failure "You have no secret keys in your keyring!
+You might want to run 'gpg --gen-key'."
+    fi
+    
+    authsubkeys=$(gpg --list-secret-keys --with-colons --fixed-list-mode \
+       --fingerprint --fingerprint $secretkeys | \
+       cut -f1,5,10,12 -d: | grep -A1 '^ssb:[^:]*::[^:]*a[^:]*$' | \
+       grep '^fpr::' | cut -f3 -d: | sort -u)
+
+    if [ -z "$authsubkeys" ]; then
+       failure "no authentication-capable subkeys available.
+You might want to 'monkeysphere gen-subkey'"
+    fi
 
-    echo "generating subkey..."
-    echo "$keyParameters" | gpg --batch --gen-key
-}
+    workingdir=$(mktemp -d)
+    umask 077
+    mkfifo "$workingdir/passphrase"
+    keysuccess=1
 
-########################################################################
-# MAIN
-########################################################################
+    # FIXME: we're currently allowing any other options to get passed
+    # through to ssh-add.  should we limit it to known ones?  For
+    # example: -d or -c and/or -t <lifetime> 
 
-COMMAND="$1"
-[ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
-shift
+    for subkey in $authsubkeys; do 
+       # choose a label by which this key will be known in the agent:
+       # we are labelling the key by User ID instead of by
+       # fingerprint, but filtering out all / characters to make sure
+       # the filename is legit.
+
+       primaryuid=$(gpg --with-colons --list-key "0x${subkey}!" | grep '^pub:' | cut -f10 -d: | tr -d /)
 
-# set ms home directory
-MS_HOME=${MS_HOME:-"$HOME"/.config/monkeysphere}
+       #kname="[monkeysphere] $primaryuid"
+       kname="$primaryuid"
 
-# load configuration file
-MS_CONF=${MS_CONF:-"$MS_HOME"/monkeysphere.conf}
-[ -e "$MS_CONF" ] && . "$MS_CONF"
+       if [ "$1" = '-d' ]; then
+           # we're removing the subkey:
+           gpg --export "0x${subkey}!" | openpgp2ssh "$subkey" > "$workingdir/$kname"
+           (cd "$workingdir" && ssh-add -d "$kname")
+       else
+           # we're adding the subkey:
+           mkfifo "$workingdir/$kname"
+           gpg --quiet --passphrase-fd 3 3<"$workingdir/passphrase" \
+               --export-options export-reset-subkey-passwd,export-minimal,no-export-attributes \
+               --export-secret-subkeys "0x${subkey}!" | openpgp2ssh "$subkey" > "$workingdir/$kname" &
+           (cd "$workingdir" && DISPLAY=nosuchdisplay SSH_ASKPASS=/bin/false ssh-add "$@" "$kname" </dev/null )&
+
+           passphrase_prompt "Enter passphrase for key $kname: " "$workingdir/passphrase"
+           wait %2
+       fi
+       keysuccess="$?"
 
-# set empty config variable with defaults
-AUTHORIZED_USER_IDS=${AUTHORIZED_USER_IDS:-"$MS_HOME"/authorized_user_ids}
-GNUPGHOME=${GNUPGHOME:-"$HOME"/.gnupg}
-KEYSERVER=${KEYSERVER:-subkeys.pgp.net}
-REQUIRED_KEY_CAPABILITY=${REQUIRED_KEY_CAPABILITY:-"e a"}
-USER_CONTROLLED_AUTHORIZED_KEYS=${USER_CONTROLLED_AUTHORIZED_KEYS:-%h/.ssh/authorized_keys}
-USER_KNOWN_HOSTS=${USER_KNOWN_HOSTS:-"$HOME"/.ssh/known_hosts}
-HASH_KNOWN_HOSTS=${HASH_KNOWN_HOSTS:-}
+       rm -f "$workingdir/$kname"
+    done
 
-export GNUPGHOME
+    rm -rf "$workingdir"
 
-# stagging locations
-hostKeysCacheDir="$MS_HOME"/host_keys
-userKeysCacheDir="$MS_HOME"/user_keys
-msAuthorizedKeys="$MS_HOME"/authorized_keys
+    # FIXME: sort out the return values: we're just returning the
+    # success or failure of the final authentication subkey in this
+    # case.  What if earlier ones failed?
+    exit "$keysuccess"
+}
 
-# make sure gpg home exists with proper permissions
+########################################################################
+# MAIN
+########################################################################
+
+# unset variables that should be defined only in config file
+unset KEYSERVER
+unset CHECK_KEYSERVER
+unset KNOWN_HOSTS
+unset HASH_KNOWN_HOSTS
+unset AUTHORIZED_KEYS
+
+# load global config
+[ -r "${ETC}/monkeysphere.conf" ] && . "${ETC}/monkeysphere.conf"
+
+# set monkeysphere home directory
+MONKEYSPHERE_HOME=${MONKEYSPHERE_HOME:="${HOME}/.monkeysphere"}
+mkdir -p -m 0700 "$MONKEYSPHERE_HOME"
+
+# load local config
+[ -e ${MONKEYSPHERE_CONFIG:="${MONKEYSPHERE_HOME}/monkeysphere.conf"} ] && . "$MONKEYSPHERE_CONFIG"
+
+# set empty config variables with ones from the environment, or from
+# config file, or with defaults
+LOG_LEVEL=${MONKEYSPHERE_LOG_LEVEL:=${LOG_LEVEL:="INFO"}}
+GNUPGHOME=${MONKEYSPHERE_GNUPGHOME:=${GNUPGHOME:="${HOME}/.gnupg"}}
+KEYSERVER=${MONKEYSPHERE_KEYSERVER:="$KEYSERVER"}
+# if keyserver not specified in env or monkeysphere.conf,
+# look in gpg.conf
+if [ -z "$KEYSERVER" ] ; then
+    if [ -f "${GNUPGHOME}/gpg.conf" ] ; then
+       KEYSERVER=$(grep -e "^[[:space:]]*keyserver " "${GNUPGHOME}/gpg.conf" | tail -1 | awk '{ print $2 }')
+    fi
+fi
+# if it's still not specified, use the default
+KEYSERVER=${KEYSERVER:="subkeys.pgp.net"}
+CHECK_KEYSERVER=${MONKEYSPHERE_CHECK_KEYSERVER:=${CHECK_KEYSERVER:="true"}}
+KNOWN_HOSTS=${MONKEYSPHERE_KNOWN_HOSTS:=${KNOWN_HOSTS:="${HOME}/.ssh/known_hosts"}}
+HASH_KNOWN_HOSTS=${MONKEYSPHERE_HASH_KNOWN_HOSTS:=${HASH_KNOWN_HOSTS:="true"}}
+AUTHORIZED_KEYS=${MONKEYSPHERE_AUTHORIZED_KEYS:=${AUTHORIZED_KEYS:="${HOME}/.ssh/authorized_keys"}}
+
+# other variables not in config file
+AUTHORIZED_USER_IDS=${MONKEYSPHERE_AUTHORIZED_USER_IDS:="${MONKEYSPHERE_HOME}/authorized_user_ids"}
+REQUIRED_HOST_KEY_CAPABILITY=${MONKEYSPHERE_REQUIRED_HOST_KEY_CAPABILITY:="a"}
+REQUIRED_USER_KEY_CAPABILITY=${MONKEYSPHERE_REQUIRED_USER_KEY_CAPABILITY:="a"}
+
+# export GNUPGHOME and make sure gpg home exists with proper
+# permissions
+export GNUPGHOME
 mkdir -p -m 0700 "$GNUPGHOME"
+export LOG_LEVEL
+
+# get subcommand
+COMMAND="$1"
+[ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
+shift
 
 case $COMMAND in
     'update-known_hosts'|'update-known-hosts'|'k')
        MODE='known_hosts'
 
-        # touch the known_hosts file to make sure it exists
-       touch "$USER_KNOWN_HOSTS"
+       # check permissions on the known_hosts file path
+       if ! check_key_file_permissions "$USER" "$KNOWN_HOSTS" ; then
+           failure "Improper permissions on known_hosts file path."
+       fi
 
         # if hosts are specified on the command line, process just
         # those hosts
        if [ "$1" ] ; then
-            for host ; do
-               process_host "$host" "$hostKeysCacheDir"
-           done
+           update_known_hosts "$@"
+           RETURN="$?"
 
-        # otherwise, if no hosts are specified, process the user
-        # known_hosts file
+        # otherwise, if no hosts are specified, process every host
+        # in the user's known_hosts file
        else
-           if [ ! -s "$USER_KNOWN_HOSTS" ] ; then
-               failure "known_hosts file '$USER_KNOWN_HOSTS' is empty."
+           # exit if the known_hosts file does not exist
+           if [ ! -e "$KNOWN_HOSTS" ] ; then
+               log error "known_hosts file '$KNOWN_HOSTS' does not exist."
+               exit
            fi
-           log "processing known_hosts file..."
-           process_known_hosts "$USER_KNOWN_HOSTS" "$hostKeysCacheDir"
+
+           process_known_hosts
+           RETURN="$?"
        fi
        ;;
 
     'update-authorized_keys'|'update-authorized-keys'|'a')
        MODE='authorized_keys'
 
-        # make sure authorized_user_ids file exists
-       if [ ! -s "$AUTHORIZED_USER_IDS" ] ; then
-           log "authorized_user_ids file is empty or does not exist."
-           exit
+       # check permissions on the authorized_user_ids file path
+       if ! check_key_file_permissions "$USER" "$AUTHORIZED_USER_IDS" ; then
+           failure "Improper permissions on authorized_user_ids file path."
+       fi
+
+       # check permissions on the authorized_keys file path
+       if ! check_key_file_permissions "$USER" "$AUTHORIZED_KEYS" ; then
+           failure "Improper permissions on authorized_keys file path."
        fi
 
-       # set user-controlled authorized_keys file path
-       userAuthorizedKeys=${USER_CONTROLLED_AUTHORIZED_KEYS/\%h/"$HOME"}
+        # exit if the authorized_user_ids file is empty
+       if [ ! -e "$AUTHORIZED_USER_IDS" ] ; then
+           log error "authorized_user_ids file '$AUTHORIZED_USER_IDS' does not exist."
+           exit
+       fi
 
-       # update authorized_keys
-       update_authorized_keys "$userKeysCacheDir" "$msAuthorizedKeys" "$userAuthorizedKeys"
+       # process authorized_user_ids file
+       process_authorized_user_ids "$AUTHORIZED_USER_IDS"
+       RETURN="$?"
        ;;
 
-    'update-userids'|'u')
-       if [ -z "$1" ] ; then
-           failure "you must specify at least one userid."
-       fi
-       for userID ; do
-           update_userid "$userID" "$userKeysCacheDir"
-       done
+    'gen-subkey'|'g')
+       gen_subkey "$@"
        ;;
 
-    'gen-ae-subkey'|'g')
-       keyID="$1"
-       if [ -z "$keyID" ] ; then
-           failure "you must specify keyid of primary key."
-       fi
-       gen_ae_subkey "$keyID"
+    'subkey-to-ssh-agent'|'s')
+       subkey_to_ssh_agent "$@"
        ;;
 
-    'help'|'h'|'?')
+    '--help'|'help'|'-h'|'h'|'?')
         usage
         ;;
 
     *)
         failure "Unknown command: '$COMMAND'
-Type 'cereal-admin help' for usage."
+Type '$PGRM help' for usage."
         ;;
 esac
+
+exit "$RETURN"